/*   QL.STUFF.C       */
/* last change 9.5.93 */

#include  "xlisp.h"
#include  <qlib.h>
#include  <stdio.h>
#ifdef V3
#include  <fcntl.h>
#endif

#ifndef V3
#define  MMP		      /* a few math rutines left out in c68v2.05 */
#endif

#define clock()     mt_rclck()
#define LBSIZE	600
extern	FILE	*tfp;	      /* transcript file	    */
static	long	qrseed = 1L;
static	unsigned char	lbuf[LBSIZE];
int	lindex;
int	lcount;

void  setup_oscheck();
char  check_ctl;

long stackwarn;
extern LVAL  s_stdout,s_stdin,s_breakenable,true,s_tracenable,s_unbound;

LVAL  grk_x,grk_y;
LVAL  k_or,k_xor,k_raw;
LVAL  k_sctop,k_scbot,k_cline,k_rline;
LVAL  k_vert,k_horiz;
LVAL  s_qdos,k_withbf,k_cure,k_curs;
struct PENPOS{	int x,y;  };
LVAL  crcoarc();
LVAL  dromv();
#ifdef V3
long  my_conread(struct UFB *,void *,unsigned int);
#endif


long _MNEED=100*1024L	       ;
long _STACK=EDEPTH*20L	       ;    /* should be enough for most aplications */
long _memincr=10*1024L	       ;
char _PROG_NAME[]="XLisp+ v2.1d";

#ifdef V3
long (*_conread)()= my_conread;
void (*_consetup)()= NULL;
/* long (*_conwrite)()= NULL; */
#endif

/* -- osinit - initialize */
VOID osinit(banner)

char	*banner;
{
	printf("%s\n", banner );
	printf("%s\n","QL port done by Richard Zidlicky");
	stackwarn=0;
	lindex	= 0;
	lcount	= 0;
	check_ctl=0;
	setup_oscheck();
}

#ifdef STACKCHECK
void stchck()
{    if(stackreport()<(stackwarn ? MARG2 : MARG1)){
	  stackwarn=1;
          if(stackreport()>MARG2) xlerror("insufficient stack ",NIL);
          dbgputstr("stack failure\n");
          xltoplevel();
       }
}
/* stackwarn wird nur durch (top-level) zurueckgesetzt */
#endif

void ossymbols()
{
	  grk_x=xlenter("GCUR-X");
	  grk_y=xlenter("GCUR-Y");
/*	  s_qdos=xlenter("QDOS"); defconstant(s_qdos,s_qdos); */
	  k_xor=xlenter(":XOR") ; defconstant(k_xor,k_xor);
	  k_or= xlenter(":OR")  ; defconstant(k_or,k_or);
	  k_raw=xlenter(":RAW") ; defconstant(k_raw,k_raw);
	  k_sctop=xlenter(":SCR-TOP"); defconstant(k_sctop,k_sctop);
	  k_scbot=xlenter(":SCR-BOT"); defconstant(k_scbot,k_scbot);
	  k_cline=xlenter(":SCR-CLN"); defconstant(k_cline,k_cline);
	  k_rline=xlenter(":SCR-RLN"); defconstant(k_rline,k_rline);
	  k_horiz=xlenter(":HORIZ")  ; defconstant(k_horiz,k_horiz);
	  k_vert =xlenter(":VERT")   ; defconstant(k_vert,k_vert);
   k_withbf=xlenter(":USE-BUFFER");defconstant(k_withbf,k_withbf);
   k_cure = xlenter(":CURSOR-ON");defconstant(k_cure,k_cure);
   k_curs =xlenter(":CURSOR-OFF");defconstant(k_curs,k_curs);
}

/* check_ctl used for messaging with oscheck */
void oschmenu()     /* level 0 i/o used here to avoid problems        */
{		    /* with not reentrant code			      */
	  char *menu="Keyboard interrupt\nF1  top-level\nF2  break\nF3  togle break mode\nF4  togle baktrace\nESC";
	  unsigned char qc;
	  chanid_t chan=io_open("con_150x70a156x28_1",0);
	  if(chan<0){         /* could be only memory overflow        */
	      check_ctl=(stackwarn ? 'T' : 'B');  /* top-level or break */
	      return ;}
	  sd_bordr(chan,-1L,4,2);
	  sd_clear(chan,-1L);
	  sd_setin(chan,-1L,7);
	  io_sstrg(chan,-1L,menu,strlen(menu));
	  for(;;){
	     sd_pos(chan,-1L,0,0);
	     io_fbyte(chan,-1L,&qc);
	     switch(qc){
		case 232 : check_ctl='C'; break;
		case 236 : check_ctl='B'; break;
		case 240 : check_ctl='D'; break;
		case 244 : check_ctl='T'; break;
		case  27 : break;
		default  : continue;
		    }
	       break;
	  }
	  io_close(chan);
}

void oscheck()
{	  char *br_msg="\n===========\n Keyboard interrupt\n";
	  char ctl;
	  LVAL sym=0;

	  /* stchck(); */    /* sollte nicht schaden, tut es aber */
	  if (ctl=check_ctl) /* stchck->dbugputstr->tputc->oscheck->stchck !!!!! */
	      {check_ctl=0;
	       ctl=(ctl>'Z' ? ctl-32 : ctl);
	       switch(ctl){
		    case 'B': xlbreak(br_msg,s_unbound);break;  /* may return here */
		    case 'C': xltoplevel();           /* never returns             */
		    case 'D': sym=s_breakenable;
		    case 'T': sym=(sym ? sym : s_tracenable);
			      setvalue(sym,( null(getvalue(sym)) ? true : NIL));  /* always returns*/
	      } 	  }
}

LVAL  xmode()
{	  return(NIL);
}

LVAL  xstackreport()
{         return cvfixnum(stackreport());
}

int gint()
{
	  LVAL xpr;
	  xpr=xleval(xlgetarg());
	  return getfixnum( fixp(xpr) ? xpr : xlbadtype(xpr));
}

chanid_t fchan(sym)
	  LVAL *sym;
{
	  FILE *fle;
	  LVAL xpr;
	  char flag=0;
	  if(moreargs() && (streamp(xpr=xleval(*xlargv))))
			{ fle=getfile(xpr);flag=1; nextarg();}
	   else
	     fle=stdout;
	  fflush(fle);
	  if(sym)(flag  ? *sym=xpr : *sym=s_stdout );
	  return(fgetchid(fle));
}

LVAL  xgetkey()
{
          LVAL fle=s_stdin;
          LVAL arg;
          chanid_t chid;
          int  err, tmout=-1;
          unsigned char qc;

       lab1:
          chid=fgetchid(getfile(fle));
          if (moreargs()){
            if (streamp(arg=xlgetarg()))  
                 { fle=arg;  goto lab1;}
            if (fixp(arg)) { tmout=getfixnum(arg); goto lab1;}

#if 0                         /* buffer handling */
            if  ( arg == k_withbf) {
                 if ((qc=getsavech(fle))!=0)
                      {setsavech(fle,'\0'); return cvfixnum(qc);}
                 if ( (fle=s_stdin)&&(lcount>0) )
                              return(cvfixnum(ostgetc()));
                      else goto lab1; }
#endif
            if  ( arg == k_cure )  {  sd_cure(chid,-1L) ; goto lab1; }
            if  ( arg == k_curs )  {  sd_curs(chid,-1L) ; goto lab1; }
               else  goto lab1;
                           }
          err=io_fbyte(chid,tmout,&qc);
          return cvfixnum(err ? err : qc );
}

LVAL  xsetpos()
{
	  chanid_t chid=fchan(0);
   int x=gint(),y=gint();
	  return(cvfixnum(sd_pos(chid,-1L,x,y )));
}

LVAL  xsetgpos()
{
	  chanid_t chid=fchan(0);
	  int gx=gint(),gy=gint(),x=gint(),y=gint();
	  return(cvfixnum(sd_igcur(chid,-1L,y,x,gy,gx)));
}

LVAL  xwmode()  /* screen write mode  (NORMAL PAINT XOR)*/
{	  LVAL mde;
	  short md;
	  chanid_t chid=fchan(0);
	  mde=(moreargs() ? xleval(xlgetarg()) : NIL);
	  md=0;
	  if(k_xor==mde) md=-1;
	  if(k_or ==mde) md= 1;
	  return(cvfixnum(sd_setmd(chid,-1,md)));
}

LVAL  xscale()
{
	  chanid_t chid;
	  int sca,x,y;
	  chid=fchan(0);
	  sca=gint(),x=gint(),y=gint();
	  return cvfixnum(sd_iscale(chid,-1L,sca,x,y));
}

LVAL  xwdef()
{
	  chanid_t chid;
	  int	  bc,bw;
	  struct QLRECT rct;
	  chid=fchan(0);
	  bc=gint();
	  bw=gint();
	  rct.q_width=gint();
	  rct.q_height=gint();
	  rct.q_x=gint();
	  rct.q_y=gint();
	  return(cvfixnum(sd_wdef(chid,-1L,bc,bw,&rct)));
}

LVAL  xscroll()
{	  LVAL richt;
	  LVAL scrspec;
	  int  (*scfun)();
	  int  dist;
	  chanid_t chid=fchan(0);
	  dist=gint();
	  scfun=sd_scrol;
	  if(moreargs())
	      richt=xlgetarg();
	      scrspec=(moreargs() ? xlgetarg() : richt);
	      if(richt==k_horiz) scfun=sd_pan;
	      if(scrspec==k_sctop) scfun=sd_scrtp;
	      else
		 if(scrspec==k_scbot) scfun=sd_scrbt;
		 else
		    if(scrspec==k_cline) scfun=sd_panln;
		    else
		       if(scrspec==k_rline) scfun=sd_panrt;
	  return(cvfixnum((*scfun)(chid,-1L,dist)));
}

LVAL  xclear()
{	  LVAL scrspec;
	  int (*clfun)();
	  chanid_t chid=fchan(0);
	  clfun=sd_clear;
	  if(moreargs())
		 scrspec=xlgetarg();
		 if(scrspec==k_sctop) clfun=sd_clrtp;
		    else
		      if(scrspec==k_scbot) clfun=sd_clrbt;
			else
			  if(scrspec==k_cline) clfun=sd_clrln;
			    else
			      if(scrspec==k_rline)  clfun=sd_clrrt;
	  return(cvfixnum((*clfun)(chid,-1L)));
}

LVAL  xcolor()
{
	  chanid_t chid;
	  chid=fchan(0);
	  return(cvfixnum(sd_setin(chid,-1L,gint())));
}

LVAL  xpaper()
{
	  chanid_t chid;
	  chid=fchan(0);
	  return(cvfixnum(sd_setpa(chid,-1L,gint())));
}

LVAL  xcircle(){return crcoarc(sd_ielipse);}
LVAL  xarc()   {return crcoarc(sd_iarc)   ;}
LVAL  crcoarc(afun)
	  int	(*afun)();
{	  chanid_t chid=fchan(0);
	  int i,x[5];
	  for(i=0;i<5;i++) x[i]=(moreargs() ? gint() : 0 );
	  return(cvfixnum((*afun)(chid,-1L,x[0],x[1],x[2],x[3],x[4])));
}				      /* swap 2<->3 in circle */

LVAL  xmove() { return dromv(-1L,0L); }
LVAL  xdraw() { return dromv(0,0) ;   }

LVAL  xmoverel() { return dromv(-1L,-1L); }
LVAL  xdrawrel() { return dromv(0,-1L) ;  }

#define gprp(sim)  (fixp(prop=(xlgetprop(flesym,sim))) ? getfixnum(prop) : 0)

LVAL dromv(mve_flag,rel_flag)
	  char rel_flag;
	  char mve_flag;
{	  LVAL	flesym,prop;
	  chanid_t chid;
	  struct PENPOS PenPos;
	  int x,y,rtval=0;
	  chid=fchan(&flesym);
	  PenPos.x=gprp(grk_x);
	  PenPos.y=gprp(grk_y);
	  do{
	     x=gint()+(rel_flag ? PenPos.x : 0);
	     y=gint()+(rel_flag ? PenPos.y : 0);
	     if(~mve_flag) rtval=sd_iline(chid,-1L,PenPos.x,PenPos.y,x,y);
	       else mve_flag=0;
	     PenPos.x=x;
	     PenPos.y=y;
	  }while(moreargs());
	  xlputprop(flesym,cvfixnum(PenPos.x),grk_x);
	  xlputprop(flesym,cvfixnum(PenPos.y),grk_y);
	  return(cvfixnum(rtval));
}

int system(cmdl)
       char  *cmdl;
{      char  *c;
       char  cmd[100];
       int i,j,clen=strlen(cmdl);
       strncpy(cmd,cmdl,100);
       c=strchr(cmd,' ');
       *c='\0';
       c=strchr(cmdl,' ');
       return(execl(cmd,-1L,cmd,c));
}

#ifdef MMP
#include <math.h>

double acos(x)  double x;
{      double rv=atan(sqrt(1-x*x)/x);
       return (x<0 ? rv+PI : rv );
}
double asin(x)  double x;
{      return atan(x/sqrt(1-x*x));
}
double cot(x)   double x;
{      return 1/tan(x);
}
double sinh(x)  double x;
{      double y=exp(x);
       return .5*(y-1/y);
}
double cosh(x)  double x;
{      double y=exp(x);
       return .5*(y+1/y);
}
double tanh(x)  double x;
{      double y=cosh(x); y*=y;
       return sqrt((y-1)/y);            /* BS 240 */
}
double tan(x)   double x;
{      double y=sin(x);
       return y/sqrt(1-y*y);
}

double atof(str)    /* doesn't check for ill' chars, but xlread does */
char  *str;
{      int sgn=1,mant=0,xp=0,dp=0;
       char c;
       double res;

       if(*str=='-') sgn=-1;
       while( c=*str ){
	  if(isdigit(c)) {
		   mant=mant*10+c-'0';
		   if(dp) xp--; }
	  else if( c=='.') dp=1;
	  else if( c=='e' || c=='E') {
		    xp=xp+atol( ++str );break; }
	  ++str;
       }
       res=(double) mant*pow(10.0,(double)xp);
       return( (sgn>0) ? res : -res );
}

#endif	  /* MMP */

/* xtime - report execution time */
/* TAA addition */	      /* taken from old xlsys.c */
#include <time.h>

LVAL xtime()
{
	LVAL expr;

	long  t1, t2;

	expr = xlgetarg();
	xllastarg();
	t1 = clock();
	xleval(expr);
	t2 = clock();
	return(cvflonum((t2-t1)*1.0));
}

/* parts of the following stuff originate from several ancient
   unixstuff files */

#ifdef PATHNAMES
/* ospopen - open using a search path */
FILE *ospopen(name, ascii)
char *name;
int ascii;  /* value not used in UNIX */
{
    FILE *fp;
    char *path = getenv(PATHNAMES);
    char *newnamep;
    char ch;
    char newname[256];

    if ( fp=fopen(name,"r") ) return fp;
    /* don't do a thing if user specifies explicit path */
    if ( path == NULL)  return fp;    /* changed by RZ */

    do {
	if (*path == '\0')  /* no more paths to check */
	    /* check current directory just in case */
	    return fopen(name, "r");

	newnamep = newname;
	while ((ch = *path++) != '\0' && ch != ';' && ch != ' ')
	    *newnamep++ = ch;

/* if (*(newnamep-1) != '/')
	    *newnamep++ = '/';  /* final path separator needed, not wanted in QDOS */
/* xlpath should look like "xlpath=path1_;path2_;path3_;path4_"*/
/* ie setenv "XLPATH=ram1_;ram1_lisp_"     */
	*newnamep = '\0';

	strcat(newname, name);
	fp = fopen(newname, "r");
    } while (fp == NULL);   /* not yet found */

    return fp;
}
#endif


/* rename argument file as backup, return success name */
/* For new systems -- if cannot do it, just return TRUE! */

int renamebackup(filename)
  char *filename;
{
    char *bufp, ch=0;

    strcpy(buf, filename);  /* make copy with .bak extension */

    bufp = &buf[strlen(buf)];   /* point to terminator */
    while (bufp > buf && (ch = *--bufp) != '.' && ch != '/') ;

    if (ch == '.') strcpy(bufp, ".bak");
    else strcat(buf, ".bak");

    unlink(buf);

    return !rename(filename, buf);
}


#if 0	/* popen doesn't work properly (pipe owned by wrong job => no E OF
	  on job-kill ) 					      */

/******************************************************************************
 * Prim_POPEN - start a process and open a pipe for read/write
 * (code stolen from xlfio.c:xopen())
 *
 * syntax: (popen <command line> :direction <direction>)
 *		    <command line> is a string to be sent to the subshell (sh).
 *		    <direction> is either :input (to read from the pipe) or
 *				 :output (to write to the pipe).
 *				 (:input is the default)
 *
 * Popen returns a stream, or NIL if files or processes couldn't be created.
 * The	success  of  the  command  execution  can be checked by examining the
 * return value of pclose.
 *
 * Added to XLISP by Niels Mayer
 ******************************************************************************/
LVAL Prim_POPEN()
{
  extern LVAL k_direction, k_input, k_output;
  char *name,*mode;
  FILE *fp;
  LVAL dir;

  /* get the process name and direction */
  name = (char *) getstring(xlgastring());
  if (!xlgetkeyarg(k_direction, &dir))
    dir = k_input;

  /* get the mode */
  if (dir == k_input)
    mode = "r",iomode= S_FORREADING;
  else if (dir == k_output)
    mode = "w",iomode= S_FORWRITING;
  else
    xlerror("bad direction",dir);

  /* try to open the file */
  return ((fp = popen(name,mode)) ? cvfile(fp,iomode) : NIL);
}


/******************************************************************************
 * Prim_PCLOSE - close a pipe opened by Prim_POPEN().
 * (code stolen from xlfio.c:xclose())
 *
 * syntax: (pclose <stream>)
 *		 <stream> is a stream created by popen.
 * returns T if the command executed successfully, otherwise,
 * returns the exit status of the opened command.
 *
 * Added to XLISP by Niels Mayer
 ******************************************************************************/
/* osclose() should be hacked to do this instead                              */
LVAL Prim_PCLOSE()
{
  extern LVAL true;
  LVAL fptr;
  int  result;

  /* get file pointer */
  fptr = xlgastream();
  xllastarg();

  /* make sure the file exists */
  if (getfile(fptr) == NULL)
    xlfail("file not open");

  /* close the pipe */
  result = pclose(getfile(fptr));

  if (result == -1)
    xlfail("<stream> has not been opened with popen");

  setfile(fptr,NULL);

  /* return T if success (exit status 0), else return exit status */
  return (result ? cvfixnum(result) : true);
}
#endif


/******************************************************************************
 * Prim_SYSTEM - run a process, sending output (if any) to stdout/stderr
 *
 * syntax: (system <command line>)
 *		<command line> is a string to be sent to the subshell (sh).
 *
 * Returns T if the command executed succesfully, otherwise returns the
 * integer shell exit status for the command.
 *
 * Added to XLISP by Niels Mayer
 ******************************************************************************/


LVAL XSYSTEM()
{
  extern LVAL true;
  extern int sys_nerr;
  extern char *sys_errlist[];
  extern int errno;
  LVAL command;
  int  result;
  char temptext[1024];

  /* get shell command */
  command = xlgastring();
  xllastarg();

  /* run the process */
  result = system((char *) getstring(command));

  if (result == -1) {      /* if a system error has occured */
    if (errno < sys_nerr)
      (void) sprintf(temptext, "Error in system(3S): %s\n", sys_errlist[errno]);
    else
      (void) strcpy(temptext, "Error in system(3S): unknown error\n");
    xlfail(temptext);
  }

  /* return T if success (exit status 0), else return exit status */
  return (result ? cvfixnum(result) : true);
}


/* -- osfinish - clean up before returning to the operating system */
VOID osfinish()
{
#ifdef KCW_INPUT	/* hacked by KCW */
	stty(0, &savetty);         /* KCW */
#endif
}


/* -- oserror - print an error message */
VOID oserror(msg)

char	*msg;

{
	printf( "error: %s\n", msg );
}

VOID xoserror(msg)

char	*msg;

{	oserror(msg);
}

/* -- osrand - return a random number between 0 and n-1 */
int osrand(n)
int	n;
{
	long k1;

	/* -- make sure we don't get stuck at zero */
	if ( qrseed == 0L ) qrseed = 1L;

	/* -- algorithm taken from Dr Dobbs Journal, Nov. 1985, page 91 */
	k1 = qrseed / 127773L;
	if ( ( qrseed = 16807L * (qrseed - k1 * 127773L) -k1 * 2836L) < 0L )
		qrseed += 2147483647L;

	/* -- return a random number between 0 and n-1 */
	return( (int) (qrseed & (long) n ) );
}


/* -- osaopen -- open an ascii file */
FILE	*osaopen( name, mode )
char	*name, *mode;
{
#ifdef WINTERP
  FILE* fp = fopen(name, mode);
  fcntl(fileno(fp), F_SETFD, 1); /* set close-on-exec */
  return (fp);
#else
	return( fopen( name, mode ) );
#endif /* WINTERP */
}


/* -- osbopen -- open a binary file */
FILE	*osbopen( name, mode )
char	*name, *mode;
{
#ifdef WINTERP
  FILE* fp = fopen(name, mode);
  fcntl(fileno(fp), F_SETFD, 1); /* set close-on-exec */
  return (fp);
#else
	return( fopen( name, mode ) );
#endif	/* WINTERP */
}


/* -- osclose -- close a file */
int	osclose( fp )
FILE	*fp;
{
#if	1
	return fclose(fp);
#else
	return( fclose( fp ) ? pclose(fp) : 0 );  /* try pclose on error, RZ */
#endif
}

/* -- ostgetc - get a character from the terminal */
  int ostgetc()
{
#if 0			      /* RZ */
	if(raw_flag) {
	       lcount=lindex=0; 	/* forget buffer */
	       io_fbyte(fgetchid(stdin),-1L,&qc);
	       io_sbyte(fgetchid(stdin),-1L,qc);            /* echo */
	       if(tfp) putc(qc,tfp);
	       oscheck();
	       return(qc);
	      }
#endif
	while(--lcount < 0 )
		{
		if ( fgets(lbuf,LBSIZE,stdin) == NULL )
		     return( EOF );
		if ( tfp )
		     fputs( lbuf, tfp );                       /* interferes with osflush */
		lcount = strlen( lbuf );
		lindex = 0;
		}
	oscheck();

	return( lbuf[lindex++] );
}

#ifdef V3
long my_conread(sufb,lbuf,lbsize)
struct UFB *sufb;
char *lbuf;
unsigned int lbsize;
{
          return io_fline(sufb->ufbfh,-1L,lbuf,lbsize);
}
#endif

/* -- ostputc - put a character to the terminal */

VOID ostputc( ch )
int	ch;
{
	/* -- check for control characters */
	oscheck();

	/* -- output the character */
	putchar( ch );

	/* -- output the char to the transcript file */
	if ( tfp )
		putc( ch, tfp );
}


/* -- osflush - flush the terminal input buffer */
VOID osflush()
{
	lindex = lcount = 0;
}

/* xflush - flush the input line buffer and start a new line */
static VOID xflush()
{
	osflush();
	ostputc('\n');
}


